import Controller from '@ember/controller';
import { computed } from '@ember/object';
import { A } from '@ember/array';
import EmberObject from '@ember/object';
import UserValidations from "../../validations/user";
import { task } from "ember-concurrency";

export default Controller.extend({
  isAddingEntry: false,
  newEntry: EmberObject.create({login: '',passwordHash: '',firstName: '',lastName: '',email: '',imageUrl: '',activated: 'false',createdBy: '',createdDate: new Date(),lastModifiedBy: '',lastModifiedDate: new Date(),authorities: [],todos: []}),
  
  UserValidations,

	authorityList: computed('authorities', function() {
		this.store.findAll('authority');
	}),
	todoList: computed('todos', function() {
		this.store.findAll('todo');
	}),

	login: null,
	passwordHash: null,
	firstName: null,
	lastName: null,
	email: null,
	imageUrl: null,
	activated: null,
	createdBy: null,
	createdDate: null,
	lastModifiedBy: null,
	lastModifiedDate: null,
	authorities: null,
	todos: null,
userTableColumns: computed(function() {
	var col = A([
		EmberObject.create({
			propertyName: "login",
			title: "login"
		}),
		EmberObject.create({
			propertyName: "passwordHash",
			title: "passwordHash"
		}),
		EmberObject.create({
			propertyName: "firstName",
			title: "firstName"
		}),
		EmberObject.create({
			propertyName: "lastName",
			title: "lastName"
		}),
		EmberObject.create({
			propertyName: "email",
			title: "email"
		}),
		EmberObject.create({
			propertyName: "imageUrl",
			title: "imageUrl"
		}),
		EmberObject.create({
			propertyName: "activated",
			title: "activated"
		}),
		EmberObject.create({
			propertyName: "createdBy",
			title: "createdBy"
		}),
		EmberObject.create({
			propertyName: "createdDate",
			title: "createdDate"
		}),
		EmberObject.create({
			propertyName: "lastModifiedBy",
			title: "lastModifiedBy"
		}),
		EmberObject.create({
			propertyName: "lastModifiedDate",
			title: "lastModifiedDate"
		})]);
	col.pushObject({
		title: 'Delete',
		component: 'delete-row'
	});
	return col;	}),
userTableContent: computed(function() {
	return this.get('users');
}),

  actions: {
    submit() {
      console.log("action submit");
    },
    deleteRecord (record) {
      console.log('record is '+ record);
      record.destroyRecord();
    }
  },
  submitEntry: task(function*(model) {
    yield model.save();
    let newEntity = this.store.createRecord('user',yield model.get('data'));
    yield newEntity.save();
    console.log("new entry of id "+newEntity.get('id')+" created");
    this.set('addEntryModal', false);
  })
});